<?php

namespace HCM\FPA\Repository;

use Doctrine\ORM\EntityManager;
use HCM\Util\DateUtil;

class RelatCustomAdmissaoRepository {

    protected  $connection;
    public function __construct(EntityManager $entityManager) {
        $this->entityManager = $entityManager;
    }

    /**
     * @return array
     */

    public function getRelatCustomAdmissao($parameters, $filters) {

        error_reporting(E_ERROR | E_PARSE);
        $dtmescompetencia = $parameters['P_DTMESCOMPETENC'];
        $generalWhere = self::getWhereFilters($filters);
        $estruturaSuperior = '';
        $nomeSuperior = '';
        if($parameters['P_NRTIPOHIERARQORG'] || $parameters['P_NRTIPOESTRUTURA'] || $parameters['P_NRESTRUTSUPERIORM']){
            $listaNomeEstrut = $parameters['P_NOMETIPOSESTRUTURA'];
            unset($parameters['P_NOMETIPOSESTRUTURA']);
            $nomeSuperior = "ESTRUTURASUPERIOR.*,";
            $estruturaSuperior = "JOIN (
SELECT *
FROM( SELECT         
         VH.NRVINCULOM,
         EM.NRESTRUTURAM,
         EM.NMESTRUTURAM,
         TPE.NMTIPOESTRUTURA
      FROM ESTRUTURAM EM
      JOIN TIPOESTRUTURA TPE ON TPE.NRTIPOESTRUTURA = EM.NRTIPOESTRUTURA
      JOIN GPE_VINCULOH VH  ON VH.NRORG = EM.NRORG  
                                AND VH.DTMESCOMPETENC = ( SELECT MAX(DTMESCOMPETENC) FROM GPE_VINCULOH H
                                                          WHERE H.NRORG = VH.NRORG  
                                                            AND H.NRVINCULOM = VH.NRVINCULOM
                                                            AND H.DTMESCOMPETENC <= :P_DTMESCOMPETENC )
      JOIN HIERARQUIAORG H ON H.NRORG            = VH.NRORG
                    AND H.NRESTRUTURAMREL  = VH.NRESTRUTGEREN
                    AND ( INSTR(','||:P_NRTIPOHIERARQORG||',', ','||H.NRTIPOHIERARQORG||',') > 0 OR :P_NRTIPOHIERARQORG IS NULL ) 
                    AND H.NRESTRUTURAMSUP  = EM.NRESTRUTURAM
                    AND H.DTINIVIGENCIA    = ( SELECT MAX(DTINIVIGENCIA) FROM HIERARQUIAORG
                                               WHERE DTINIVIGENCIA <= LAST_DAY(:P_DTMESCOMPETENC) 
                                                 AND NRORG            = H.NRORG
                                                 AND NRESTRUTURAMREL  = H.NRESTRUTURAMREL
                                                 AND NRTIPOHIERARQORG = H.NRTIPOHIERARQORG )
      WHERE EM.NRORG           = :P_NRORG
        AND ( INSTR(','||:P_NRTIPOESTRUTURA||',', ','||EM.NRTIPOESTRUTURA||',') > 0  OR :P_NRTIPOESTRUTURA   IS NULL)
        AND ( INSTR(','||:P_NRESTRUTSUPERIORM||',', ','||EM.NRESTRUTURAM   ||',') > 0  OR :P_NRESTRUTSUPERIORM IS NULL)
    )
    PIVOT ( MAX(NRESTRUTURAM) as NR,
              MAX(NMESTRUTURAM) AS NM
              FOR NMTIPOESTRUTURA IN ($listaNomeEstrut))) ESTRUTURASUPERIOR ON ESTRUTURASUPERIOR.NRVINCULOM = GPE_VINCULOM.NRVINCULOM";
        }
        
        if(array_key_exists('NRTIPOHIERARQORG', $parameters)) {
            $tipohierarquia = $parameters['NRTIPOHIERARQORG'];
            $tipohierarquia = "AND (HIERARQUIAORG.NRTIPOHIERARQORG IN ($tipohierarquia) OR HIERARQUIAORG.NRTIPOHIERARQORG IS NULL)";
        }else{
          $tipohierarquia =  "AND 1 = 2";
        }

        $whereativo = "";
        $vinculosativos = (isset($parameters['VINCULOSATIVOS'])?$parameters['VINCULOSATIVOS']:'S');
        if ($vinculosativos == 'S') {
            $whereativo = "AND GPE_VINCULOM.DTADMISSAOVINC <= LAST_DAY(TO_DATE('$dtmescompetencia'))
                           AND ((GPE_VINCULOM.DTADMISSAOVINC <> GPE_VINCULOM.DTRESCISAOVINC AND GPE_VINCULOM.DTRESCISAOVINC >= '$dtmescompetencia') OR GPE_VINCULOM.DTRESCISAOVINC IS NULL)";
        } elseif ($vinculosativos == 'P') {
            $dtiniperiodo = $parameters['DTINIPERIODO'];
            $dtfimperiodo = $parameters['DTFIMPERIODO'];
            $whereativo = "AND GPE_VINCULOM.DTADMISSAOVINC <= '$dtfimperiodo'
                           AND (GPE_VINCULOM.DTRESCISAOVINC IS NULL OR GPE_VINCULOM.DTRESCISAOVINC >= '$dtiniperiodo')";
        } else {
            $whereativo = "AND (GPE_VINCULOM.DTRESCISAOVINC IS NOT NULL OR GPE_VINCULOM.DTRESCISAOVINC >= '$dtmescompetencia')";
        }
        
        if(array_key_exists('LIST_NRESTRUTLEGAL', $parameters)) {
            $nrestrutlegal = implode(",", $parameters['LIST_NRESTRUTLEGAL']);
            $condEstrutLegal = "AND GPE_VINCULOH.NRESTRUTLEGAL IN ($nrestrutlegal)";
        } else {
            $condEstrutLegal = "";
        }

        if(array_key_exists('LIST_NRESTRUTGEREN', $parameters)) {
            $nrestrutgeren = implode(",", $parameters['LIST_NRESTRUTGEREN']);
            $condEstrutGeren = "AND GPE_VINCULOH.NRESTRUTGEREN IN ($nrestrutgeren)";
        } else {
            $condEstrutGeren = "";
        }
        
        if(array_key_exists('NRVINCULOM', $parameters)) {
            $nrvinculom = $parameters['NRVINCULOM'];
            $condListVinculo = "AND GPE_VINCULOH.NRVINCULOM IN ($nrvinculom)";
        } else {
            $condListVinculo = "";
        }

       
      // Monta joins com dependentes e tipos de relacionamento dos mesmos caso seja informado no filtro que é para exibir dependentes
      $colunasDependente = $joinDependentes = " ";

      if($parameters['IDEXIBIRDEP'] == 'S'){

         $joinDependentes = " LEFT JOIN RELACIONAPARC RPD
                ON RPD.NRORG = GPE_PESSOA.NRORG
                AND RPD.NRPARCNEGOCIO = GPE_PESSOA.NRPARCNEGOCIO
            LEFT JOIN TIPORELACIONA TPRP
                ON TPRP.NRORG IN (0, RPD.NRORG)
                AND TPRP.NRTIPORELACIONA = RPD.NRTIPORELACIONA
            LEFT JOIN GPE_PESSOA PD
                ON PD.NRORG = RPD.NRORG
                AND PD.NRPARCNEGOCIO = RPD.NRPARCNEGRELAC
            LEFT JOIN GPE_PESSOAH PHD
                ON PHD.NRORG = GPE_PESSOA.NRORG
                AND PHD.NRPESSOA = PD.NRPESSOA
                AND PHD.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC)
                                            FROM GPE_PESSOAH
                                            WHERE NRORG = PHD.NRORG
                                            AND NRPESSOA = PHD.NRPESSOA
                                            AND DTMESCOMPETENC <= '$dtmescompetencia'
                                         )
            LEFT JOIN FPA_DEPVINCULO DV
                ON DV.NRORG = GPE_VINCULOM.NRORG
                AND DV.NRVINCULOM = GPE_VINCULOM.NRVINCULOM
                AND DV.NRPESSOA = PD.NRPESSOA
                AND (DV.DTFINDEPENDE IS NULL OR DV.DTFINDEPENDE >= '$dtmescompetencia')
            LEFT JOIN FPA_TIPODEPENDE TPD
                ON TPD.NRORG IN(0, DV.NRORG)
                AND TPD.NRTIPODEPENDE = DV.NRTIPODEPENDE
            ";

          $colunasDependente =  "
                ,PHD.NMPESSOA NMPESSOA_DEP,
                TPRP.NMTIPORELACIONA NMTIPORELACIONA_DEP,
                TPD.NMTIPODEPENDE NMTIPODEPENDE_DEP,
                PD.NRPESSOA NRPESSOA_DEP,
                PHD.DTNASCPESSOA DTNASCPESSOA_DEP,
                PHD.NRCPFPESSOA NRCPFPESSOA_DEP,
                PHD.IDSEXOPESSOA IDSEXOPESSOA_DEP
            ";
      }

      $sql = "
        SELECT EMAIL.CDCOMUNICAPARC AS EMAIL,
                    ENDERECOPARC.CDBAIRRO,
                    ENDERECOPARC.CDLOGRADOURO,
                    ENDERECOPARC.CDMUNICIPIO,
                    ENDERECOPARC.CDPAIS,
                    ENDERECOPARC.DSCOMPLEENDERECO,
                    PAIS.NMPAIS,
                    ESTADO.NMESTADO,
                    MUNICIPIO.NMMUNICIPIO,
                    EHL.NMESTRUTURAH AS NMESTRUTLEGAL, /*rafaelpck 175852 04/02/2019*/
                    EHG.NMESTRUTURAH AS NMESTRUTGEREN,
                    EHS.NMESTRUTURAH AS NMESTRUTSIND,
                    HIERARQUIAORG.NRTIPOHIERARQORG AS TIPOHIERARQORG,
                    ESTRUTSUPERIORM.NRESTRUTURAM AS NRESTRUTSUPERIORM,
                    ESTRUTSUPERIORH.NMESTRUTURAH AS NMESTRUTSUPERIORM,
                    ENDERECOPARC.DSENDERECO,
                    ENDERECOPARC.NMBAIRROENDERECO,
                    ENDERECOPARC.NRCEPENDERECO,
                    ENDERECOPARC.NRIMOVELENDERECO,
                    ENDERECOPARC.SGESTADO,
                    ALTESAL_ATUAL.VRSALARIO,
                    ROUND(NVL(ALTESAL_ATUAL.VRPERCREAL, DECODE(ALTESAL_ANT.VRSALARIO, NULL, NULL, ( (ALTESAL_ATUAL.VRSALARIO / ALTESAL_ANT.VRSALARIO) - 1) * 100) ), 2) AS VRPERCREAL, 
                    
                    (
                        CASE WHEN NVL(GPE_VINCULOM.DTRESCISAOVINC, LAST_DAY(TO_DATE(:P_DTMESCOMPETENC, 'DD/MM/YYYY'))) > GPE_VINCULOM.DTADMISSAOVINC THEN (
                             (TRUNC( MONTHS_BETWEEN( NVL(GPE_VINCULOM.DTRESCISAOVINC, LAST_DAY(TO_DATE(:P_DTMESCOMPETENC, 'DD/MM/YYYY'))), GPE_VINCULOM.DTADMISSAOVINC ) /12 )) || ' ano(s), ' ||
                             (MOD( TRUNC( MONTHS_BETWEEN( NVL(GPE_VINCULOM.DTRESCISAOVINC, LAST_DAY(TO_DATE(:P_DTMESCOMPETENC, 'DD/MM/YYYY'))), GPE_VINCULOM.DTADMISSAOVINC ) ), 12 )) || ' mes(es) e ' ||
                             TRUNC(NVL(GPE_VINCULOM.DTRESCISAOVINC, LAST_DAY(TO_DATE(:P_DTMESCOMPETENC, 'DD/MM/YYYY'))) - ADD_MONTHS(GPE_VINCULOM.DTADMISSAOVINC,TRUNC( MONTHS_BETWEEN( NVL(GPE_VINCULOM.DTRESCISAOVINC, LAST_DAY(TO_DATE(:P_DTMESCOMPETENC, 'DD/MM/YYYY'))), GPE_VINCULOM.DTADMISSAOVINC ) )))  || ' dia(s)'
                        )    
                        END
                    ) TEMPOSERVICO,

                    GPE_ESCALATRABH.NRESCALATRABM,
                    GPE_ESCALATRABH.NMESCALATRABH,
                    GPE_PESSOA.NRPESSOA,
                    GPE_PESSOAH.CDESTACIVIL,
                    GPE_PESSOAH.CDEXCERTRESEPES,
                    GPE_PESSOAH.CDEXRGPESSOA,
                    GPE_PESSOAH.CDTPBAIXAPAG,
                    GPE_PESSOAH.DSAPELIDOPESS,
                    GPE_PESSOAH.DSCATEGCERTRESE,
                    GPE_PESSOAH.DSCATEGHABCART,
                    GPE_PESSOAH.DSLOCALEXRGPES,
                    GPE_PESSOAH.DSNOMEMEIOPESS,
                    GPE_PESSOAH.DSPRINOMEPESS,
                    GPE_PESSOAH.DSPRONOMETRAT,
                    GPE_PESSOAH.DSULTNOMEPESS,
                    SUBSTR(GPE_PESSOAH.DTCASAPESSOA,1,10) DTCASAPESSOA,
                    SUBSTR(GPE_PESSOAH.DTCERTRESEPES,1,10) DTCERTRESEPES,
                    SUBSTR(GPE_PESSOAH.DTCTPSPESSOA,1,10) DTCTPSPESSOA,
                    SUBSTR(GPE_PESSOAH.DTEXCONSREG,1,10) DTEXCONSREG,
                    SUBSTR(GPE_PESSOAH.DTEXRGPESSOA,1,10) DTEXRGPESSOA,
                    SUBSTR(GPE_PESSOAH.DTHABCARTPES,1,10) DTHABCARTPES,
                    SUBSTR(GPE_PESSOAH.DTINSCPISPASEP,1,10) DTINSCPISPASEP,
                    SUBSTR(GPE_PESSOAH.DTNASCPESSOA, 1, 10) DTNASCPESSOA,
                    SUBSTR(GPE_PESSOAH.DTNATURALIZAPES,1,10) DTNATURALIZAPES,
                    SUBSTR(GPE_PESSOAH.DTPERMAVISTO,1,10) DTPERMAVISTO,
                    SUBSTR(GPE_PESSOAH.DTVALHABCARTPES,1,10) DTVALHABCARTPES,
                    GPE_PESSOAH.IDFATORRHPES,
                    GPE_PESSOAH.IDGRUPSANGUPES,
                    GPE_PESSOAH.IDISENTITUELEI,
                    GPE_PESSOAH.IDPESNATURALIZA,
                    GPE_PESSOAH.IDPOSVISTOPERM,
                    GPE_PESSOAH.IDSEXOPESSOA,
                    GPE_PESSOAH.NMPESSOA,
                    GPE_PESSOAH.DTNASCPESSOA,
                    GPE_PESSOAH.NRANOCHEGAPAIS,
                    GPE_PESSOAH.NRCARTHABPES,
                    GPE_PESSOAH.NRCATMILITARPE,
                    GPE_PESSOAH.NRCERTCASAPES,
                    GPE_PESSOAH.NRCERTNASCPES,
                    GPE_PESSOAH.NRCERTRESEPES,
                    GPE_PESSOAH.NRCONDFISPES,
                    GPE_PESSOAH.NRCONSELHOREG,
                    GPE_PESSOAH.NRCPFPESSOA,
                    GPE_PESSOAH.NRCTPSPESSOA,
                    GPE_PESSOAH.NRDOCUESTRANG,
                    GPE_PESSOAH.NRGRAUINSTR,
                    GPE_PESSOAH.NRINSCINSSPES,
                    GPE_PESSOAH.NRINSCISSPES,
                    GPE_PESSOAH.NRINSCRCONSREG,
                    GPE_PESSOAH.NRNACIONALID,
                    GPE_PESSOAH.NRPISPASEPPES,
                    GPE_PESSOAH.NRRACAPESSOA,
                    GPE_PESSOAH.NRREGCTPSPES,
                    GPE_PESSOAH.NRRGPESSOA,
                    GPE_PESSOAH.NRSECAELEIPES,
                    GPE_PESSOAH.NRSERIECTPSPES,
                    GPE_PESSOAH.NRTITUELEIPES,
                    GPE_PESSOAH.NRZONAELEIPES,
                    GPE_PESSOAH.SGUFCONSREG,
                    GPE_PESSOAH.SGUFCTPSPES,
                    GPE_PESSOAH.SGUFRGPESSOA,
                    GPE_PESSOAH.NRSUSPESSOA,
                    GPE_PESSOAH.NRNITPESSOA,
                    PN_M.NMPRINCIPALPARC NMMAE, /*Nome da mãe*/
                    PN_P.NMPRINCIPALPARC NMPAI, /*Nome da mãe*/
                    GPE_SITUFUNCM.NRSITUFUNCM,
                    GPE_SITUFUNCH.NMSITUFUNCH,
                    SUBSTR(GPE_ALTESITUFUNC.DTINISITUFUNC,1,10) DTINISITUFUNC,
                    SUBSTR(GPE_ALTESITUFUNC.DTFIMSITUFUNC,1,10) DTFIMSITUFUNC,
                    GPE_VINCULOH.CDCONTRIBINDIVIDUAL,
                    GPE_VINCULOH.CONFIDENCIAL,
                    SUBSTR(GPE_VINCULOH.DTBASEFERIAS,1,10) DTBASEFERIAS,
                    SUBSTR(GPE_VINCULOH.DTFIMCONTRDETERMIN,1,10) DTFIMCONTRDETER,
                    GPE_VINCULOH.IDCONTRIBUISIND,
                    GPE_VINCULOH.IDMULTVINC,
                    GPE_VINCULOH.IDREMUNERACAO,
                    GPE_VINCULOH.IDTPPAGAMENTO,
                    GPE_VINCULOH.NRCARGO,
                    OCUPACAOH_CARGO.NMOCUPACAOH AS NMCARGO,
                    CBO_CARGO.NRCBO AS NRCBOCARGO,
                    CBO_CARGO.NMCBO AS NMCBOCARGO,
                    AO.NROCUPACAOM, /*alteração de ocupação*/
                    OH.NMOCUPACAOH,
                    AO.DTINIOCUPACAO,
                    GPE_VINCULOH.NRDEPENDIR,
                    GPE_VINCULOH.NRDEPENDSFAM,
                    GPE_VINCULOH.NRDIASAPURVALES,
                    GPE_VINCULOH.NRESTRUTGEREN,
                    GPE_VINCULOH.NRESTRUTLEGAL,
                    GPE_VINCULOH.NRESTRUTSIND,
                    ESTRUTMOVIMM.NRESTRUTURAM AS NRESTRUTMOVIMM,
                    ESTRUTMOVIMH.NMESTRUTURAH AS NMESTRUTMOVIMM,
                    GPE_VINCULOH.NRFUNCAO,
                    OCUPACAOH_FUNCAO.NMOCUPACAOH AS NMFUNCAO,
                    CBO_FUNCAO.NRCBO AS NRCBOFUNCAO,
                    CBO_FUNCAO.NMCBO AS NMCBOFUNCAO,
                    GPE_VINCULOH.NRTPMODALIDSAL,
                    GPE_VINCULOH.NRTPMOVTRANSFM,
                    GPE_VINCULOH.NRTPREGIMEPREV,
                    GPE_ALTEESCALA.NRTURNO,
                    GPE_VINCULOM.NRVINCULOM,
                    GPE_VINCULOM.NMVINCULOM AS NMVINCULOM,
                    GPE_VINCULOM.CDMATRICULA,
                    GPE_VINCULOH.CDMATRICULAESOCIAL,
                    GPE_VINCULOM.DSLIVROADMISSAO,
                    GPE_VINCULOM.DSOBSRESCISAO,
                    SUBSTR(GPE_VINCULOM.DTADMISSAOVINC,1,10) DTADMISSAOVINC,
                    SUBSTR(GPE_VINCULOM.DTAPOSENTAFGTS,1,10) DTAPOSENTAFGTS,
                    SUBSTR(GPE_VINCULOM.DTAVISOPREVIO,1,10) DTAVISOPREVIO,
                    SUBSTR(GPE_VINCULOM.DTAVISOTRCT,1,10) DTAVISOTRCT,
                    SUBSTR(GPE_VINCULOM.DTEXAMEMEDICO,1,10) DTEXAMEMEDICO,
                    SUBSTR(GPE_VINCULOM.DTOPCAOFGTS,1,10) DTOPCAOFGTS,
                    SUBSTR(GPE_VINCULOM.DTPRIMADMISSAO,1,10) DTPRIMADMISSAO,
                    SUBSTR(GPE_VINCULOM.DTRESCISAOVINC,1,10) DTRESCISAOVINC,
                    GPE_VINCULOM.IDSEGDESEMPVINC,
                    GPE_VINCULOM.NRDIASCONTRATOEXP,
                    GPE_VINCULOM.NRDIASCONTRATOEXPPRO,
                    GPE_VINCULOM.NRMOTIVORESC,
                    GPE_MOTIVORESC.NMMOTIVORESC AS NMMOTIVORESC,
                    GPE_VINCULOM.NRORG,
                    GPE_VINCULOM.NRTIPOVINCULOM,
                    GPE_VINCULOM.NRTPADMISSAO,
                    GPE_VINCULOM.NRTPAVIPRE,
                    GPE_VINCULOM.NRTPDEMISSAO,
                    FPA_TPDEMISSAO.NMABREV AS NMTPDEMISSAO,
                    GPE_VINCULOM.NRVINCULOEMPREG,
                    TELEFONE_PRINCIPAL.CDCOMUNICAPARC AS TELEFONE_PRINCIPAL,
                    TELEFONE_PRINCIPAL.CDPREFIXCOMUPARC AS DDD_TELEFONE,
                    TELEFONE_PRINCIPAL.DSCONTATO AS CONTATO_TELEFONE,
                    CELULAR.CDCOMUNICAPARC AS CELULAR,
                    CELULAR.CDPREFIXCOMUPARC AS DDD_CELULAR,
                    CELULAR.DSCONTATO AS CONTATO_CELULAR,
                    BANCO.CDBANCO,
                    BANCO.NMBANCO AS NMBANCO,
                    CONTCORRPARC.CDAGENCIA,
                    AGENCIA.NMAGENCIA AS NMAGENCIA,
                    CONTCORRPARC.CDCONTCORR,
                    GPE_CATMILITARPE.NMCATMILITARPE,
                    GPE_CONDFISPES.DSCONDFISPES,
                    GPE_CONSELHOREG.NMCONSELHOREG,
                    GPE_GRAUINSTR.NMGRAUINSTR,
                    GPE_NACIONALIDADE.DSNACIONALIDADE,
                    GPE_RACAPESSOA.NMRACAPESSOA,
                    LOGRADOURO.DSLOGRADOURO,
                    ESTADOCIVIL.NMESTACIVIL,
                    FPA_TPADMISSAO.NMTPADMISSAO,
                    GPE_TIPOAVISOPRE.DSTPAVIPRE,
                    GPE_VINCULOEMPREG.NMABREV,
                    TVH.NMTIPOVINCULOH,
                    $nomeSuperior
                    FPA_TPMODALIDSAL.NMTPMODALIDSAL
                    $colunasDependente

            /* VÍNCULO */
            FROM GPE_VINCULOM

            INNER JOIN GPE_VINCULOH
                ON GPE_VINCULOM.NRVINCULOM = GPE_VINCULOH.NRVINCULOM
                AND GPE_VINCULOM.NRORG = GPE_VINCULOH.NRORG
                AND GPE_VINCULOH.DTMESCOMPETENC = (SELECT MAX(MAX_VINCULOH.DTMESCOMPETENC)
                                                     FROM GPE_VINCULOH MAX_VINCULOH
                                                    WHERE MAX_VINCULOH.NRVINCULOM = GPE_VINCULOH.NRVINCULOM
                                                      AND MAX_VINCULOH.NRORG = GPE_VINCULOH.NRORG
                                                      AND MAX_VINCULOH.DTMESCOMPETENC <= :P_DTMESCOMPETENC)

            /*Estrutura Legal e Gerencial*/ /*rafaelpck 175852 04/02/2019*/
            LEFT JOIN ESTRUTURAH EHL ON EHL.NRORG        = GPE_VINCULOM.NRORG
                                    AND EHL.NRESTRUTURAM = GPE_VINCULOH.NRESTRUTLEGAL
                                    AND EHL.DTMESCOMPETENC = ( SELECT MAX(DTMESCOMPETENC) FROM ESTRUTURAH
                                                               WHERE DTMESCOMPETENC <= :P_DTMESCOMPETENC
                                                                 AND NRORG        = EHL.NRORG
                                                                 AND NRESTRUTURAM = EHL.NRESTRUTURAM )
            LEFT JOIN ESTRUTURAH EHG ON EHG.NRORG        = GPE_VINCULOM.NRORG
                                    AND EHG.NRESTRUTURAM = GPE_VINCULOH.NRESTRUTGEREN
                                    AND EHG.DTMESCOMPETENC = ( SELECT MAX(DTMESCOMPETENC) FROM ESTRUTURAH
                                                               WHERE DTMESCOMPETENC <= :P_DTMESCOMPETENC
                                                                 AND NRORG        = EHG.NRORG
                                                                 AND NRESTRUTURAM = EHG.NRESTRUTURAM )
            LEFT JOIN ESTRUTURAH EHS ON EHS.NRORG        = GPE_VINCULOM.NRORG
                                    AND EHS.NRESTRUTURAM = GPE_VINCULOH.NRESTRUTSIND
                                    AND EHS.DTMESCOMPETENC = ( SELECT MAX(DTMESCOMPETENC) FROM ESTRUTURAH
                                                               WHERE DTMESCOMPETENC <= :P_DTMESCOMPETENC
                                                                 AND NRORG        = EHS.NRORG
                                                                 AND NRESTRUTURAM = EHS.NRESTRUTURAM )
            LEFT JOIN GPE_TIPOVINCULOH TVH
            ON GPE_VINCULOM.NRTIPOVINCULOM = TVH.NRTIPOVINCULOM
            AND (TVH.NRORG = GPE_VINCULOM.NRORG 
                OR TVH.NRORG = :P_NRORG_PADRAO)

            /* PESSOA */
            INNER JOIN GPE_PESSOA
                ON GPE_VINCULOM.NRPESSOA = GPE_PESSOA.NRPESSOA
                AND GPE_VINCULOM.NRORG = GPE_PESSOA.NRORG

            INNER JOIN GPE_PESSOAH
                ON GPE_PESSOAH.NRPESSOA = GPE_PESSOA.NRPESSOA
                AND GPE_PESSOAH.NRORG = GPE_PESSOA.NRORG
                AND GPE_PESSOAH.DTMESCOMPETENC = (SELECT MAX(MAX_PESSOAH.DTMESCOMPETENC)
                                                    FROM GPE_PESSOAH MAX_PESSOAH
                                                   WHERE MAX_PESSOAH.NRPESSOA = GPE_PESSOAH.NRPESSOA
                                                     AND MAX_PESSOAH.NRORG = GPE_PESSOAH.NRORG
                                                     AND MAX_PESSOAH.DTMESCOMPETENC <= :P_DTMESCOMPETENC)

            /*Relacionamento - Nome do Pai e da Mãe*/
            LEFT JOIN RELACIONAPARC RP_M ON RP_M.NRORG = GPE_PESSOA.NRORG
                AND RP_M.NRPARCNEGOCIO = GPE_PESSOA.NRPARCNEGOCIO
                AND RP_M.NRTIPORELACIONA = 1 /*Mãe*/
            LEFT JOIN PARCNEGOCIO PN_M ON PN_M.NRORG = RP_M.NRORG
                AND PN_M.NRPARCNEGOCIO = RP_M.NRPARCNEGRELAC

            LEFT JOIN RELACIONAPARC RP_P ON RP_P.NRORG = GPE_PESSOA.NRORG
                AND RP_P.NRPARCNEGOCIO = GPE_PESSOA.NRPARCNEGOCIO
                AND RP_P.NRTIPORELACIONA = 2 /*Pai*/
            LEFT JOIN PARCNEGOCIO PN_P ON PN_P.NRORG = RP_P.NRORG
                AND PN_P.NRPARCNEGOCIO = RP_P.NRPARCNEGRELAC

            /* OCUPACAO E FUNÇÃO */
            LEFT JOIN GPE_OCUPACAOM OCUPACAOM_CARGO
                ON GPE_VINCULOH.NRCARGO = OCUPACAOM_CARGO.NROCUPACAOM
                AND GPE_VINCULOM.NRORG = OCUPACAOM_CARGO.NRORG
            LEFT JOIN GPE_OCUPACAOH OCUPACAOH_CARGO
                ON OCUPACAOM_CARGO.NROCUPACAOM = OCUPACAOH_CARGO.NROCUPACAOM
                AND OCUPACAOM_CARGO.NRORG = OCUPACAOH_CARGO.NRORG
                AND OCUPACAOH_CARGO.DTMESCOMPETENC = (SELECT MAX(OCUPACAOH.DTMESCOMPETENC)
                                                    FROM GPE_OCUPACAOH OCUPACAOH
                                                   WHERE OCUPACAOH.NROCUPACAOM = OCUPACAOH_CARGO.NROCUPACAOM
                                                     AND OCUPACAOH.NRORG = OCUPACAOH_CARGO.NRORG
                                                     AND OCUPACAOH.DTMESCOMPETENC <= :P_DTMESCOMPETENC)
            LEFT JOIN GPE_CBO CBO_CARGO ON CBO_CARGO.NRCBO = OCUPACAOH_CARGO.NRCBO
            LEFT JOIN GPE_OCUPACAOM OCUPACAOM_FUNCAO
                ON GPE_VINCULOH.NRFUNCAO = OCUPACAOM_FUNCAO.NROCUPACAOM
                AND GPE_VINCULOM.NRORG = OCUPACAOM_FUNCAO.NRORG
            LEFT JOIN GPE_OCUPACAOH OCUPACAOH_FUNCAO
                ON OCUPACAOM_FUNCAO.NROCUPACAOM = OCUPACAOH_FUNCAO.NROCUPACAOM
                AND OCUPACAOM_FUNCAO.NRORG = OCUPACAOH_FUNCAO.NRORG
                AND OCUPACAOH_FUNCAO.DTMESCOMPETENC = (SELECT MAX(OCUPACAOH.DTMESCOMPETENC)
                                                    FROM GPE_OCUPACAOH OCUPACAOH
                                                   WHERE OCUPACAOH.NROCUPACAOM = OCUPACAOH_FUNCAO.NROCUPACAOM
                                                     AND OCUPACAOH.NRORG = OCUPACAOH_FUNCAO.NRORG
                                                     AND OCUPACAOH.DTMESCOMPETENC <= :P_DTMESCOMPETENC)
            LEFT JOIN GPE_CBO CBO_FUNCAO ON CBO_FUNCAO.NRCBO = OCUPACAOH_FUNCAO.NRCBO
            
             /*ALTERAÇÃO DE OCUPAÇÃO - CARGO E FUNÇÃO*/
            LEFT JOIN GPE_ALTEOCUPACAO AO ON AO.NRORG      = GPE_VINCULOM.NRORG
                                         AND AO.NRVINCULOM = GPE_VINCULOM.NRVINCULOM
                                         AND AO.DTINIOCUPACAO = ( SELECT MAX(DTINIOCUPACAO) FROM GPE_ALTEOCUPACAO
                                                                  WHERE NRORG          = AO.NRORG
                                                                    AND NRVINCULOM     = AO.NRVINCULOM
                                                                    AND DTINIOCUPACAO <= LAST_DAY(TO_DATE(:P_DTMESCOMPETENC, 'DD/MM/YYYY')) )
            LEFT JOIN GPE_OCUPACAOH OH ON OH.NRORG          = GPE_VINCULOM.NRORG
                                      AND OH.NROCUPACAOM    = AO.NROCUPACAOM
                                      AND OH.DTMESCOMPETENC = ( SELECT MAX(DTMESCOMPETENC) FROM GPE_OCUPACAOH
                                                                WHERE NRORG           = OH.NRORG
                                                                  AND NROCUPACAOM     = AO.NROCUPACAOM
                                                                  AND DTMESCOMPETENC <= TO_DATE(:P_DTMESCOMPETENC, 'DD/MM/YYYY') )
            /* SITUAÇÃO FUNCIONAL*/
            LEFT JOIN GPE_ALTESITUFUNC
                    ON GPE_ALTESITUFUNC.NRVINCULOM = GPE_VINCULOM.NRVINCULOM
                   AND GPE_ALTESITUFUNC.NRORG = GPE_VINCULOM.NRORG
                   AND GPE_ALTESITUFUNC.NRSITUFUNCM <> 12
                   AND GPE_ALTESITUFUNC.DTINISITUFUNC = (SELECT MAX(MAX_ALTESITUFUNC.DTINISITUFUNC)
                                                        FROM GPE_ALTESITUFUNC MAX_ALTESITUFUNC
                                                       WHERE MAX_ALTESITUFUNC.NRVINCULOM = GPE_ALTESITUFUNC.NRVINCULOM
                                                         AND MAX_ALTESITUFUNC.NRORG = GPE_ALTESITUFUNC.NRORG
                                                         AND MAX_ALTESITUFUNC.NRSITUFUNCM <> 12
                                                         AND MAX_ALTESITUFUNC.DTINISITUFUNC <= LAST_DAY(:P_DTMESCOMPETENC))

            LEFT JOIN GPE_SITUFUNCM
                ON GPE_SITUFUNCM.NRSITUFUNCM = GPE_ALTESITUFUNC.NRSITUFUNCM
                AND (GPE_SITUFUNCM.NRORG = GPE_ALTESITUFUNC.NRORG OR GPE_SITUFUNCM.NRORG = :P_NRORG_PADRAO OR GPE_SITUFUNCM.NRORG IS NULL)
            LEFT JOIN GPE_SITUFUNCH
                ON GPE_SITUFUNCH.NRSITUFUNCM = GPE_SITUFUNCM.NRSITUFUNCM
                AND (GPE_SITUFUNCH.NRORG = GPE_SITUFUNCM.NRORG OR GPE_SITUFUNCH.NRORG = :P_NRORG_PADRAO OR GPE_SITUFUNCH.NRORG IS NULL)
                AND GPE_SITUFUNCH.DTEFETIVA = (SELECT MAX(MAX_SITUFUNCH.DTEFETIVA)
                                                 FROM GPE_SITUFUNCH MAX_SITUFUNCH
                                                WHERE MAX_SITUFUNCH.NRSITUFUNCM = GPE_SITUFUNCH.NRSITUFUNCM
                                                  AND MAX_SITUFUNCH.DTEFETIVA <= :P_DTMESCOMPETENC)
            /* ALTERAÇÃO DE SALÁRIO */
            INNER JOIN GPE_ALTESALARIO ALTESAL_ATUAL
                ON ALTESAL_ATUAL.NRVINCULOM = GPE_VINCULOM.NRVINCULOM
                AND ALTESAL_ATUAL.NRORG = GPE_VINCULOM.NRORG
                AND ALTESAL_ATUAL.DTALTESALARIO = (SELECT MAX(MAX_ALTESALARIO.DTALTESALARIO)
                                                       FROM GPE_ALTESALARIO MAX_ALTESALARIO
                                                      WHERE MAX_ALTESALARIO.NRVINCULOM = ALTESAL_ATUAL.NRVINCULOM
                                                        AND MAX_ALTESALARIO.NRORG = ALTESAL_ATUAL.NRORG
                                                        AND MAX_ALTESALARIO.DTALTESALARIO <= LAST_DAY(:P_DTMESCOMPETENC))
                AND ALTESAL_ATUAL.NROCORRENCIA = (SELECT MAX(MAX_ALTESALARIO.NROCORRENCIA)
                                                       FROM GPE_ALTESALARIO MAX_ALTESALARIO
                                                      WHERE MAX_ALTESALARIO.NRVINCULOM = ALTESAL_ATUAL.NRVINCULOM
                                                        AND MAX_ALTESALARIO.NRORG = ALTESAL_ATUAL.NRORG
                                                        AND MAX_ALTESALARIO.DTALTESALARIO = ALTESAL_ATUAL.DTALTESALARIO)
                AND ALTESAL_ATUAL.VRSALARIO > 0                                                        

            /* ALTERAÇÃO DE SALÁRIO ANTERIOR*/
            LEFT JOIN GPE_ALTESALARIO ALTESAL_ANT
                ON ALTESAL_ANT.NRVINCULOM = GPE_VINCULOM.NRVINCULOM
                AND ALTESAL_ANT.NRORG = GPE_VINCULOM.NRORG
                AND ALTESAL_ANT.DTALTESALARIO = (SELECT MAX(MAX_ALTESALARIO.DTALTESALARIO)
                                                       FROM GPE_ALTESALARIO MAX_ALTESALARIO
                                                      WHERE MAX_ALTESALARIO.NRVINCULOM = ALTESAL_ANT.NRVINCULOM
                                                        AND MAX_ALTESALARIO.NRORG = ALTESAL_ANT.NRORG
                                                        AND MAX_ALTESALARIO.DTALTESALARIO <= LAST_DAY(:P_DTMESCOMPETENC)
                                                        AND MAX_ALTESALARIO.DTALTESALARIO <> ALTESAL_ATUAL.DTALTESALARIO)
                AND ALTESAL_ANT.NROCORRENCIA = (SELECT MAX(MAX_ALTESALARIO.NROCORRENCIA)
                                                       FROM GPE_ALTESALARIO MAX_ALTESALARIO
                                                      WHERE MAX_ALTESALARIO.NRVINCULOM = ALTESAL_ATUAL.NRVINCULOM
                                                        AND MAX_ALTESALARIO.NRORG = ALTESAL_ATUAL.NRORG
                                                        AND MAX_ALTESALARIO.DTALTESALARIO <> ALTESAL_ATUAL.DTALTESALARIO)
                AND ALTESAL_ANT.VRSALARIO > 0  

        
            /* ESCALA TRABALHO */
            LEFT JOIN GPE_ALTEESCALA
                ON GPE_VINCULOM.NRVINCULOM         = GPE_ALTEESCALA.NRVINCULOM
                AND GPE_VINCULOM.NRORG             = GPE_ALTEESCALA.NRORG
                AND GPE_ALTEESCALA.DTINIESCALA = (SELECT MAX(MAX_ALTEESCALA.DTINIESCALA)
                                                    FROM GPE_ALTEESCALA MAX_ALTEESCALA
                                                   WHERE MAX_ALTEESCALA.NRVINCULOM = GPE_ALTEESCALA.NRVINCULOM
                                                     AND MAX_ALTEESCALA.NRORG      = GPE_ALTEESCALA.NRORG
                                                     AND MAX_ALTEESCALA.DTINIESCALA <= LAST_DAY(:P_DTMESCOMPETENC))

            LEFT JOIN GPE_ESCALATRABH
                ON GPE_ESCALATRABH.NRESCALATRABM = GPE_ALTEESCALA.NRESCALATRABM
                AND GPE_ESCALATRABH.NRORG = GPE_ALTEESCALA.NRORG
                AND GPE_ESCALATRABH.DTMESCOMPETENC = (SELECT MAX(MAX_ESCALATRABH.DTMESCOMPETENC)
                                                        FROM GPE_ESCALATRABH MAX_ESCALATRABH
                                                       WHERE MAX_ESCALATRABH.NRORG = GPE_ALTEESCALA.NRORG
                                                         AND MAX_ESCALATRABH.NRESCALATRABM = GPE_ALTEESCALA.NRESCALATRABM
                                                         AND MAX_ESCALATRABH.DTMESCOMPETENC <= :P_DTMESCOMPETENC)

            /* PARCEIRO DE NEGÓCIO */
            INNER JOIN PARCNEGOCIO
                ON PARCNEGOCIO.NRPARCNEGOCIO = GPE_PESSOA.NRPARCNEGOCIO
                AND PARCNEGOCIO.NRORG = GPE_PESSOA.NRORG

            /* TELEFONE PRINCIPAL*/
            LEFT JOIN COMUNICAPARC TELEFONE_PRINCIPAL
                ON TELEFONE_PRINCIPAL.NRPARCNEGOCIO = PARCNEGOCIO.NRPARCNEGOCIO
                AND TELEFONE_PRINCIPAL.NRORG = PARCNEGOCIO.NRORG
                AND TELEFONE_PRINCIPAL.CDFORMACOMU = '01'
                AND TELEFONE_PRINCIPAL.NRCOMUNICAPARC = (
                                                            SELECT MAX(NRCOMUNICAPARC) FROM COMUNICAPARC MAX_TP
                                                            WHERE MAX_TP.NRPARCNEGOCIO = TELEFONE_PRINCIPAL.NRPARCNEGOCIO
                                                            AND MAX_TP.NRORG = TELEFONE_PRINCIPAL.NRORG
                                                            AND MAX_TP.CDFORMACOMU = TELEFONE_PRINCIPAL.CDFORMACOMU
                                                        )

            /* CELULAR*/
            LEFT JOIN COMUNICAPARC CELULAR
                ON CELULAR.NRPARCNEGOCIO = PARCNEGOCIO.NRPARCNEGOCIO
                AND CELULAR.NRORG = PARCNEGOCIO.NRORG
                AND CELULAR.CDFORMACOMU = '02'
                AND CELULAR.NRCOMUNICAPARC = (
                                                SELECT MAX(NRCOMUNICAPARC) FROM COMUNICAPARC MAX_CEL
                                                WHERE MAX_CEL.NRPARCNEGOCIO = CELULAR.NRPARCNEGOCIO
                                                AND MAX_CEL.NRORG = CELULAR.NRORG
                                                AND MAX_CEL.CDFORMACOMU = CELULAR.CDFORMACOMU
                                              )

            /* EMAIL */
            LEFT JOIN COMUNICAPARC EMAIL
                ON EMAIL.NRPARCNEGOCIO = PARCNEGOCIO.NRPARCNEGOCIO
                AND EMAIL.NRORG = PARCNEGOCIO.NRORG
                AND EMAIL.CDFORMACOMU = '05'
                AND EMAIL.NRCOMUNICAPARC = (
                                                SELECT MAX(NRCOMUNICAPARC) FROM COMUNICAPARC MAX_EMAIL
                                                WHERE MAX_EMAIL.NRPARCNEGOCIO = EMAIL.NRPARCNEGOCIO
                                                AND MAX_EMAIL.NRORG = EMAIL.NRORG
                                                AND MAX_EMAIL.CDFORMACOMU = EMAIL.CDFORMACOMU
                                           )

            /* ENDEREÇO */
            LEFT JOIN ENDERECOPARC
                ON PARCNEGOCIO.NRPARCNEGOCIO = ENDERECOPARC.NRPARCNEGOCIO
                AND PARCNEGOCIO.NRORG = ENDERECOPARC.NRORG
                AND ENDERECOPARC.CDTIPOENDERECO = 'PRINCIPAL'
                AND ENDERECOPARC.NRENDERECOPARC = (
                                                    SELECT MAX(NRENDERECOPARC) FROM ENDERECOPARC E_MAX
                                                    WHERE E_MAX.NRPARCNEGOCIO = PARCNEGOCIO.NRPARCNEGOCIO 
                                                    AND E_MAX.NRORG = ENDERECOPARC.NRORG
                                                    AND E_MAX.CDTIPOENDERECO = ENDERECOPARC.CDTIPOENDERECO
                                                  )

            /* PAIS */
            LEFT JOIN PAIS
                ON ENDERECOPARC.CDPAIS = PAIS.CDPAIS

            /* ESTADO */
              LEFT JOIN ESTADO
                ON ENDERECOPARC.CDPAIS   = ESTADO.CDPAIS
               AND ENDERECOPARC.SGESTADO = ESTADO.SGESTADO

            /* MUNICIPIO */
            LEFT JOIN MUNICIPIO
                ON ENDERECOPARC.CDPAIS      = MUNICIPIO.CDPAIS
               AND ENDERECOPARC.SGESTADO    = MUNICIPIO.SGESTADO
               AND ENDERECOPARC.CDMUNICIPIO = MUNICIPIO.CDMUNICIPIO

            /* TIPO MODALIDADE SALARIO */
            LEFT JOIN FPA_TPMODALIDSAL
                ON FPA_TPMODALIDSAL.NRTPMODALIDSAL = GPE_VINCULOH.NRTPMODALIDSAL
               AND (FPA_TPMODALIDSAL.NRORG = GPE_VINCULOH.NRORG OR FPA_TPMODALIDSAL.NRORG = :P_NRORG_PADRAO)

            /* INFORMAÇÔES BANCÁRIAS*/
            LEFT JOIN CONTCORRPARC
                   ON CONTCORRPARC.NRORG = GPE_VINCULOM.NRORG
                  AND CONTCORRPARC.NRPARCNEGOCIO = GPE_PESSOA.NRPARCNEGOCIO
                  AND CONTCORRPARC.IDATIVO        = 'S'
                  AND CONTCORRPARC.NRCONTCORRPARC = ( SELECT MAX(NRCONTCORRPARC) NRCONTCORRPARC
                                                      FROM CONTCORRPARC C
                                                      WHERE NRORG = GPE_PESSOA.NRORG
                                                        AND NRPARCNEGOCIO = GPE_PESSOA.NRPARCNEGOCIO)
            LEFT JOIN BANCO
                   ON BANCO.CDBANCO = CONTCORRPARC.CDBANCO
                  AND (BANCO.NRORG = GPE_VINCULOM.NRORG OR BANCO.NRORG = :P_NRORG_PADRAO)
            LEFT JOIN AGENCIA
                   ON AGENCIA.CDAGENCIA = CONTCORRPARC.CDAGENCIA
                  AND AGENCIA.CDBANCO   = CONTCORRPARC.CDBANCO
                  AND (AGENCIA.NRORG = GPE_VINCULOM.NRORG OR AGENCIA.NRORG = :P_NRORG_PADRAO)
            /*RESCISÃO*/
            LEFT JOIN FPA_TPDEMISSAO
                   ON FPA_TPDEMISSAO.NRTPDEMISSAO = GPE_VINCULOM.NRTPDEMISSAO
            LEFT JOIN GPE_MOTIVORESC
                   ON GPE_MOTIVORESC.NRMOTIVORESC = GPE_VINCULOM.NRMOTIVORESC
            /*ESTRUTURA SUPERIOR*/
            LEFT JOIN HIERARQUIAORG
                   ON HIERARQUIAORG.NRESTRUTURAMREL  = GPE_VINCULOH.NRESTRUTGEREN
                  AND HIERARQUIAORG.NRORG            = GPE_VINCULOM.NRORG
                  $tipohierarquia
            LEFT JOIN ESTRUTURAM ESTRUTSUPERIORM
                   ON (GPE_VINCULOH.NRORG         = ESTRUTSUPERIORM.NRORG
                  AND  HIERARQUIAORG.NRESTRUTURAMSUP = ESTRUTSUPERIORM.NRESTRUTURAM)
            LEFT JOIN ESTRUTURAH ESTRUTSUPERIORH
                   ON (ESTRUTSUPERIORM.NRORG        = ESTRUTSUPERIORH.NRORG
                  AND  ESTRUTSUPERIORM.NRESTRUTURAM = ESTRUTSUPERIORH.NRESTRUTURAM)
                  AND  ESTRUTSUPERIORH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC)
                                                           FROM ESTRUTURAH
                                                          WHERE ESTRUTURAH.NRORG            = ESTRUTSUPERIORH.NRORG
                                                            AND ESTRUTURAH.NRESTRUTURAM       = ESTRUTSUPERIORH.NRESTRUTURAM
                                                            AND ESTRUTURAH.DTMESCOMPETENC <= TO_DATE(:P_DTMESCOMPETENC, 'DD/MM/YYYY'))
                 $estruturaSuperior

        /*ESTRUTURA MOVIMENTAÇÃO*/
        LEFT JOIN ESTRUTURAM ESTRUTMOVIMM ON ESTRUTMOVIMM.NRORG        = GPE_VINCULOH.NRORG
                                         AND ESTRUTMOVIMM.NRESTRUTURAM = ( SELECT NRESTRUTURAM FROM GPE_MOVIMENTACAO M
                                                                          WHERE M.DTINIMOVIMENT = ( SELECT MAX(DTINIMOVIMENT) FROM GPE_MOVIMENTACAO
                                                                                                    WHERE DTINIMOVIMENT <= LAST_DAY(:P_DTMESCOMPETENC)
                                                                                                      AND NRTIPOESTRUTURA = M.NRTIPOESTRUTURA
                                                                                                      AND NRORG           = GPE_VINCULOH.NRORG
                                                                                                      AND NRVINCULOM      = GPE_VINCULOH.NRVINCULOM )
                                                                            AND M.NRMOVIMENTACAO = ( SELECT MAX(NRMOVIMENTACAO) FROM GPE_MOVIMENTACAO
                                                                                                     WHERE DTINIMOVIMENT = M.DTINIMOVIMENT
                                                                                                      AND NRTIPOESTRUTURA = M.NRTIPOESTRUTURA
                                                                                                      AND NRORG = GPE_VINCULOH.NRORG
                                                                                                      AND NRVINCULOM = GPE_VINCULOH.NRVINCULOM )
                                                                            AND M.NRTIPOESTRUTURA = :P_NRTPESTRUTMOVIM
                                                                            AND M.NRORG = GPE_VINCULOH.NRORG
                                                                            AND M.NRVINCULOM = GPE_VINCULOH.NRVINCULOM )
        LEFT JOIN ESTRUTURAH ESTRUTMOVIMH ON ESTRUTMOVIMH.NRORG          = GPE_VINCULOH.NRORG
                                         AND ESTRUTMOVIMH.NRESTRUTURAM   = ESTRUTMOVIMM.NRESTRUTURAM
                                         AND ESTRUTMOVIMH.DTMESCOMPETENC = ( SELECT MAX(DTMESCOMPETENC) FROM ESTRUTURAH
                                                                             WHERE DTMESCOMPETENC <= LAST_DAY(:P_DTMESCOMPETENC)
                                                                               AND NRORG        = GPE_VINCULOH.NRORG
                                                                               AND NRESTRUTURAM = ESTRUTMOVIMM.NRESTRUTURAM )

            LEFT JOIN GPE_CATMILITARPE 
                   ON GPE_PESSOAH.NRCATMILITARPE = GPE_CATMILITARPE.NRCATMILITARPE
                  AND (GPE_CATMILITARPE.NRORG = :P_NRORG_PADRAO OR GPE_CATMILITARPE.NRORG = :P_NRORG)
            LEFT JOIN GPE_CONDFISPES 
                   ON GPE_PESSOAH.NRCONDFISPES = GPE_CONDFISPES.NRCONDFISPES
                  AND (GPE_CONDFISPES.NRORG = :P_NRORG_PADRAO OR GPE_CONDFISPES.NRORG = :P_NRORG)
            LEFT JOIN GPE_CONSELHOREG 
                   ON GPE_PESSOAH.NRCONSELHOREG = GPE_CONSELHOREG.NRCONSELHOREG
                  AND (GPE_CONSELHOREG.NRORG = :P_NRORG_PADRAO OR GPE_CONSELHOREG.NRORG = :P_NRORG)
            LEFT JOIN GPE_GRAUINSTR 
                   ON GPE_PESSOAH.NRGRAUINSTR = GPE_GRAUINSTR.NRGRAUINSTR
                  AND (GPE_GRAUINSTR.NRORG = :P_NRORG_PADRAO OR GPE_GRAUINSTR.NRORG = :P_NRORG)
            LEFT JOIN GPE_NACIONALIDADE 
                   ON GPE_PESSOAH.NRNACIONALID = GPE_NACIONALIDADE.NRNACIONALIDADE
                  AND (GPE_NACIONALIDADE.NRORG = :P_NRORG_PADRAO OR GPE_NACIONALIDADE.NRORG = :P_NRORG)
            LEFT JOIN GPE_RACAPESSOA 
                   ON GPE_PESSOAH.NRRACAPESSOA = GPE_RACAPESSOA.NRRACAPESSOA
                  AND (GPE_RACAPESSOA.NRORG = :P_NRORG_PADRAO OR GPE_RACAPESSOA.NRORG = :P_NRORG)
            LEFT JOIN LOGRADOURO 
                   ON ENDERECOPARC.CDLOGRADOURO = LOGRADOURO.CDLOGRADOURO
                  AND (LOGRADOURO.NRORG = :P_NRORG_PADRAO OR LOGRADOURO.NRORG = :P_NRORG)
            LEFT JOIN ESTADOCIVIL 
                   ON GPE_PESSOAH.CDESTACIVIL = ESTADOCIVIL.CDESTACIVIL
                  AND (ESTADOCIVIL.NRORG = :P_NRORG_PADRAO OR ESTADOCIVIL.NRORG = :P_NRORG)
            LEFT JOIN FPA_TPADMISSAO 
                   ON GPE_VINCULOM.NRTPADMISSAO = FPA_TPADMISSAO.NRTPADMISSAO
                  AND (FPA_TPADMISSAO.NRORG = :P_NRORG_PADRAO OR FPA_TPADMISSAO.NRORG = :P_NRORG) 
            LEFT JOIN GPE_TIPOAVISOPRE 
                   ON GPE_VINCULOM.NRTPAVIPRE = GPE_TIPOAVISOPRE.NRTPAVIPRE
                  AND (GPE_TIPOAVISOPRE.NRORG = :P_NRORG_PADRAO OR GPE_TIPOAVISOPRE.NRORG = :P_NRORG)
            LEFT JOIN GPE_VINCULOEMPREG 
                   ON GPE_VINCULOM.NRVINCULOEMPREG = GPE_VINCULOEMPREG.NRVINCULOEMPREG
                  AND (GPE_VINCULOEMPREG.NRORG = :P_NRORG_PADRAO OR GPE_VINCULOEMPREG.NRORG = :P_NRORG)

            /*Dependentes e tipo de relacionamento dos mesmos*/
            $joinDependentes

            WHERE GPE_VINCULOM.NRORG = :P_NRORG
            $whereativo
            $condListVinculo
            $condEstrutLegal
            $condEstrutGeren
            $generalWhere
            ORDER BY GPE_PESSOAH.NMPESSOA
        ";
        
        $query = $this->entityManager->getConnection()->prepare($sql);
        
        $query->execute($parameters);
        return $query->fetchAll();
    }

    public function getWhereFilters($filters) {
     	$whereFilter = " ";
     	foreach ($filters as $filter) {
     	    if($filter['columnName']=='DTADMISSAOVINC')
     	    $whereFilter .= " AND GPE_VINCULOM.DTADMISSAOVINC BETWEEN '".$filter['value'][0]."' AND '".$filter['value'][1]."' ";
     	    else if($filter['columnName']=='DTRESCISAOVINC')
            $whereFilter .= " AND GPE_VINCULOM.DTRESCISAOVINC BETWEEN '".$filter['value'][0]."'AND '".$filter['value'][1]."' ";
            else if($filter['columnName']=='NRTIPOHIERARQORG')
     	    $whereFilter .= " AND HIERARQUIAORG.NRTIPOHIERARQORG = '".$filter['value']."' ";
     	    else if($filter['columnName']=='NRESTRUTSUPERIORM')
            $whereFilter .= " AND ESTRUTSUPERIORM.NRESTRUTURAM = '".$filter['value']."' ";
     	    else if($filter['columnName']=='NRESTRUTSIND')
     	    $whereFilter .= " AND GPE_VINCULOH.NRESTRUTSIND = '".$filter['value']."' ";
     	    else if($filter['columnName']=='NRTIPOVINCULOM')
     	    $whereFilter .= " AND GPE_VINCULOM.NRTIPOVINCULOM = '".$filter['value']."' ";
     	    else if($filter['columnName']=='NRTPADMISSAO')
     	    $whereFilter .= " AND GPE_VINCULOM.NRTPADMISSAO = '".$filter['value']."' ";
     	    else if($filter['columnName']=='NRTPDEMISSAO')
     	    $whereFilter .= " AND GPE_VINCULOM.NRTPDEMISSAO = '".$filter['value']."' ";
     	    else if($filter['columnName']=='DTINIPERIODO')
     	    $whereFilter .= " AND  <= '".$filter['value']."' ";
     	    else if($filter['columnName']=='DTFIMPERIODO')
     	    $whereFilter .= " AND  >= '".$filter['value']."' ";
     	}
     	return $whereFilter;

    }

    public function getNomeTipoEstrutura($params){
        $query = $this->entityManager->getConnection()->prepare(
        "SELECT LISTAGG('''' || NMTIPOESTRUTURA || ''' AS ' || REPLACE(NMTIPOESTRUTURA,' ','_'), ', ') WITHIN GROUP (ORDER BY NMTIPOESTRUTURA) NMTIPOESTRUTURA
           FROM (SELECT DISTINCT TPE.NMTIPOESTRUTURA
                   FROM HIERARQUIAORG H
                   JOIN TIPOHIERARQORG TP ON TP.NRTIPOHIERARQORG = H.NRTIPOHIERARQORG
                   JOIN TIPOESTRUTURA TPE ON TPE.NRTIPOESTRUTURA = TP.NRTIPOESTRUTSUP
                  WHERE H.NRORG = :P_NRORG
                    AND ( INSTR(','||:P_NRTIPOHIERARQORG||',', ','||H.NRTIPOHIERARQORG||',') > 0 OR :P_NRTIPOHIERARQORG IS NULL )
                    AND ( INSTR(','||:P_NRTIPOESTRUTURA||',', ','||TPE.NRTIPOESTRUTURA||',') > 0 OR :P_NRTIPOESTRUTURA IS NULL )
                    AND H.DTINIVIGENCIA    = ( SELECT MAX(DTINIVIGENCIA) FROM HIERARQUIAORG
                                                WHERE DTINIVIGENCIA <= LAST_DAY(:P_DTMESCOMPETENC) 
                                                  AND NRORG            = H.NRORG
                                                  AND NRESTRUTURAMREL  = H.NRESTRUTURAMREL
                                                  AND NRTIPOHIERARQORG = H.NRTIPOHIERARQORG ))");

        $query->execute($params);
        return $query->fetchAll();

    }

}