<?php
namespace Fiscal\Logic\Parametros;

use \Geral\Entities\Tipooperac;
use \Geral\Util\Ambiente;
use \Geral\Util\DateUtil;
use \Setforms2\Shared\Registry;

class ParametrosFiscal {

    /**
     * Atualiza o IDTPFATAPURA do tipo de operação para compor ou deduzir do faturamento na apuração.
     *
     * @param $cdtipooper
     * @param $idtpfatapura
     * @param $identrsaidop
     * @param $nrorg
     * @throws \Exception
     */
    public static function updateTipoOperFaturamento($cdtipooper, $idtpfatapura, $identrsaidop, $nrorg)
    {
        try {
            $tipooperac = Tipooperac::findOneByCdtipooperAndIdentrsaidopAndNrorg($cdtipooper, $identrsaidop, $nrorg);
            $tipooperac->setIdtpfatapura($idtpfatapura);
            $tipooperac->setDtultatu(DateUtil::getDataAtual());
            $tipooperac->setNrorgultatu(Ambiente::getNrorg());
            $tipooperac->setCdoperultatu(Ambiente::getCdOperador());
            $tipooperac->persist();
            Registry::getEntityManager()->flush();
        } catch (\Exception $e) {
            throw $e;
        }
    }

    /**
     * Valida se o tipo de operação já compõe ou deduz do faturamento
     *
     * @param $cdtipooper
     * @param $identrsaidop
     * @param $nrorg
     * @throws \Exception
     */
    public static function validaTipoOperJaIncluiFatur($cdtipooper, $identrsaidop, $nrorg)
    {
        try {
            $tipooperac = Tipooperac::findOneByCdtipooperAndIdentrsaidopAndNrorg($cdtipooper, $identrsaidop, $nrorg);
            if ($tipooperac->getIdtpfatapura() != null) {
                Exceptions\ExcecaoParametros::TipoOperJaIncluiFatur();
            }
        } catch(\Exception $e) {
            throw $e;
        }
    }
}